{*****************************************************}
{                                                     }
{               FastReport v2.4                       }
{              ExcelExportFilter Range                }
{       (C) Konstantin Butov for FR 2.4               }
{     For question mail to : kos@sp.iae.nsk.su        }
{                ICQ: 48750138                        }
{*****************************************************}
{Histo :                                              }
{ 14/10/00 : Version 1.001 Create                     }
{*****************************************************}

unit FR_E_BsExl01;

interface

{$I FR.inc}

uses
  SysUtils, Windows, Messages, Classes, Graphics, Forms, StdCtrls,
  FR_Class, Controls
  ,FR_progr
    ,Excel97
{$IFDEF Delphi6}
, Variants
{$ENDIF};


Type

   PmyfrView = ^TmyfrView;
   TmyfrView = record
      X,Y, dx: Integer;
      Text: String;
      FontName: String[32];
      FontSize, FontStyle, FontColor, FontCharset, FillColor: Integer;
      DrawRect: TRect;
      FrameTyp: Integer;
      Alignment: Integer;
   end;


   TfrExcelExportFilter01 = class(TfrExportFilter)
   protected
      Fexcel    : TExcelApplication;
      FWorksheet: _Worksheet;
      FWorkbook : _Workbook;
      Flcid : LCID;

      FRow, FCol: Integer;
      FPage :Integer;

      FScaleX, FScaleY: Double;
      FKillEmptyLines,  FExportFrames,
      FUsePseudographic, FPageBreaks: Boolean;
          public
           constructor Create(AOwner: TComponent); override;
       destructor Destroy; override;
       procedure ClearLines; override;
                                procedure  OnBeginDoc; override;
                                procedure  OnEndDoc;  override;
       procedure OnBeginPage; override;
       procedure OnEndPage; override;
       procedure OnData(x, y: Integer; View: TfrView); override;

       function  GetColumnChar(value: Integer) : String;


  published
    property ScaleX: Double read FScaleX write FScaleX;
    property ScaleY: Double read FScaleY write FScaleY;
    property KillEmptyLines: Boolean read FKillEmptyLines write FKillEmptyLines default True;
    property ExportFrames: Boolean read FExportFrames write FExportFrames default False;
    property UsePseudographic: Boolean read FUsePseudographic write FUsePseudographic default False;
    property PageBreaks: Boolean read FPageBreaks write FPageBreaks default True;

   end;




implementation

uses FR_Utils, FR_Const
  //OleServer, Activex ,
//  Excel2000
;

///{...$R *.DFM}


{ TfrExcelExportFilter01 }

procedure TfrExcelExportFilter01.ClearLines;
var
  i: Integer;
  p: PmyfrView;
begin
  for i := 0 to Lines.Count - 1 do
  begin
    p := PmyfrView(Lines[i]);
    Dispose(p);
  end;
  Lines.Clear;
end;

constructor TfrExcelExportFilter01.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
   frRegisterExportFilter(Self, 'Excel file 01 (*.xls)', '*.xls');

  ShowDialog := True;
  ScaleX := 1;
  ScaleY := 1;
  KillEmptyLines := True;
  ExportFrames := False;
  UsePseudographic := False;
  PageBreaks := True;
  FRow := 1;
  FCol := 1;
end;

destructor TfrExcelExportFilter01.Destroy;
begin
  frUnRegisterExportFilter(Self);
  inherited Destroy;
end;




function TfrExcelExportFilter01.GetColumnChar(value: Integer): String;
begin
  if Value < 1 then Result:='A'
  else
  begin
    if Value > 702 then
      Result:='ZZ'
    else
    begin
      if Value > 26 then begin
       if (Value mod 26)=0 then
        Result:=Chr(64 + (Value div 26)-1)
       else
        Result:=Chr(64 + (Value div 26));
         if (Value mod 26)=0 then
          result:=result+chr(64+26)
         else
          result:=Result+Chr(64 + (Value mod 26));
      end
      else
        Result:=Chr(64 + Value);
    end;
  end;
end;

procedure TfrExcelExportFilter01.OnBeginDoc;
begin
        try
 Fexcel := TExcelApplication.Create(self);
 FExcel.Connect;
        except
   on E: Exception do
   begin
    Application.MessageBox('Failed to open Excel.', Pchar(e.Message), MB_ICONERROR);
    exit;
   end;
 end;
 Flcid := GetUserDefaultLCID;
 FExcel.Visible[Flcid]:=True;
 FWorkbook := FExcel.WorkBooks.Add(EmptyParam, Flcid );
 FWorkSheet := FExcel.ActiveSheet as _Worksheet;
// FWorksheet.Name := FileName;
 FRow :=1 ;FCol := 1;
 FPage := 0;
end;

procedure TfrExcelExportFilter01.OnBeginPage;
begin
   ClearLines;
end;

procedure TfrExcelExportFilter01.OnData(x, y: Integer; View: TfrView);
Var //p : PfrView ;
      P: PmyfrView;
     I: integer;
//     TfrMemoView
begin
  if View = nil then Exit;

  New(p);
  p^.X := View.X;
  p^.Y := View.Y;
  p^.dx := View.dx;
  p^.Text :='';  // View.Memo.Text  ...
  for i :=0 to View.Memo.Count -1 do
  begin
     p^.Text := p^.Text + View.Memo[i];//+#13#10;
     if View.Memo.Count > 1 then
        p^.Text := p^.Text + ' ';
  end;
  if trim(p^.Text) ='' then
  begin
     Dispose(p);
     exit;
  end;

  if View is TfrMemoView then
    with View as TfrMemoView do
    begin
      p^.Alignment := Alignment;
      p^.FontName := Font.Name;
      p^.FontSize := Font.Size;
      p^.FontStyle := frGetFontStyle(Font.Style);
      p^.FontColor := Font.Color;
{$IFNDEF Delphi2}
      p^.FontCharset := Font.Charset;
{$ENDIF}
  p^.FrameTyp := View.FrameTyp;
  p^.FillColor := View.FillColor;
  end;
  Lines.Add(p);
end;

procedure TfrExcelExportFilter01.OnEndDoc;
begin
{       FWorkbook.SaveAs(FileName+'_1',
             xlTextWindows, EmptyParam, EmptyParam, EmptyParam, EmptyParam,
             xlNoChange, EmptyParam, EmptyParam, EmptyParam, EmptyParam,
             1);}
//   FWorkbook.Disconnect;
//   FWorkSheet.Disconnect;
  FExcel.Visible[Flcid]:=True;
//   FExcel.Disconnect;
                FExcel.Free;
end;

procedure TfrExcelExportFilter01.OnEndPage;
var
  i,iMin : Integer;
  P: PmyfrView;
  s, s1,s2, sRow, sCol: String;
        rn1 :variant;
begin

  iMin := 100; //   
  for i := 0 to Lines.Count - 1 do
  begin
     p := PmyfrView(Lines[i]);
     if iMin > p.dx then
        iMin := p.dx;
  end;
  for i := 0 to Lines.Count - 1 do
  begin
    s := '';
    p := PmyfrView(Lines[i]); //PfrTextRec(Lines[i]);
    begin
      FCol := Round(p^.X / (iMin / ScaleX)); // 85
      FRow := Round(p^.Y / (16 / ScaleY));   //14
      if FRow < 1 then FRow := 1;
      if FCol < 1 then FCol := 1;
     INC(FRow,Fpage);

     s1 := GetColumnChar(FCol)+IntTostr(FRow);
     if p^.dx >= imin *2 then
        s2 := GetColumnChar(FCol+((p^.dx - 5 )div iMin))+IntTostr(FRow)
     else s2 := s1;
        rn1 := FWorksheet.Range[s1,s2];
      rn1.Merge(False);
//      rn1.HorizontalAlignment := xlCenter;
//      rn1.VerticalAlignment := xlCenter;
//    FWorksheet.Range['A1',GetColumnChar(FRow)+'1'].ColumnWidth:= 20;
//    FWorksheet.Range['A1',GetColumnChar(FFieldNames.Count)+'1'].EntireColumn.Autofit;
//    FWorksheet.Range[StrBeginCell,StrEndCell].NumberFormat := '@' //other cases automatic 'general'

      rn1.value := p.Text;
     if(p.FrameTyp and frftTop) <> 0 then
        rn1.Borders.Item[xlEdgeTop].Linestyle := xlSolid;
     if (p.FrameTyp and frftLeft) <> 0 then
        rn1.Borders.Item[xlEdgeLeft].Linestyle := xlSolid;
     if (p.FrameTyp and frftRight) <> 0 then
        rn1.Borders.Item[xlEdgeRight].Linestyle := xlSolid;
     if (p.FrameTyp and frftBottom) <> 0 then
         rn1.Borders.Item[xlEdgeBottom].Linestyle := xlSolid;

      if p.FillColor <> 536870911 then
        rn1.Interior.Color := p.FillColor;

      rn1.EntireRow.Font.Name := p.FontName;
      rn1.EntireRow.Font.Size := p.FontSize;
      rn1.EntireRow.Font.Color:=p.FontColor;
{       if (p.FontStyle = 0 ) then
         FWorksheet.Cells.Item[FRow, FCol].EntireRow.Font.fontStyle := 'Bold';
       if p.FontStyle = 1 then
         FWorksheet.Cells.Item[FRow, FCol].EntireRow.Font.fontStyle := 'Italic';
       if p.FontStyle = 2 then
         FWorksheet.Cells.Item[FRow, FCol].EntireRow.Font.fontStyle := 'UnderLine';
}
       if (p.FontStyle = 0 ) then
         rn1.EntireRow.Font.fontStyle := 'Bold';
       if p.FontStyle = 1 then
         rn1.EntireRow.Font.fontStyle := 'Italic';
       if p.FontStyle = 2 then
         rn1.EntireRow.Font.fontStyle := 'UnderLine';
//frtaLeft, frtaRight, frtaCenter, frtaVertical, frtaMiddle, frtaDown
      case p.Alignment of
       frtaRight : rn1.EntireRow.HorizontalAlignment := xlRight;
       frtaLeft  : rn1.EntireRow.HorizontalAlignment := xlLeft;
       frtaCenter: rn1.EntireRow.HorizontalAlignment := xlCenter;
      end;
      INC(FCol);

      Application.ProcessMessages;
//      if FR_Class.frProgressForm.ModalResult := mrCancel then
//         break;
    end;
   end;
  FPage := FRow;
end;


end.
//******************************************************************************************************
//******************************************************************************************************
//******************************************************************************************************


